Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 2636)
@@ -13,4 +13,5 @@
    USE in_out_manager  ! I/O manager
    USE dom_oce         ! ocean space and time domain
+   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90	(revision 2636)
@@ -11,5 +11,4 @@
    !!             2.0  !  2007-04  (C. Deltel, G. Madec) Free form and modules
    !!----------------------------------------------------------------------
-
 #if defined key_lobster
    !!----------------------------------------------------------------------
@@ -21,10 +20,4 @@
    IMPLICIT NONE
    PUBLIC
-
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
 
    !!  biological parameters
@@ -108,27 +101,26 @@
    REAL(wp), ALLOCATABLE, SAVE,  DIMENSION(:,:) ::   cmask       !: ???
 
-   !!======================================================================
-
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   FUNCTION sms_lobster_alloc()
+   INTEGER FUNCTION sms_lobster_alloc()
       !!----------------------------------------------------------------------
       !!        *** ROUTINE sms_lobster_alloc ***
       !!----------------------------------------------------------------------
-      USE in_out_manager, ONLY: ctl_warn
-      INTEGER :: sms_lobster_alloc
+      USE lib_mpp, ONLY: ctl_warn
       !!----------------------------------------------------------------------
-
-      ALLOCATE(remdmp(jpk,jp_lobster),                                &
-               neln(jpi,jpj),    xze(jpi,jpj),     xpar(jpi,jpj,jpk), &
-               dminl(jpi,jpj),   dmin3(jpi,jpj,jpk),                  &
-               sedpocb(jpi,jpj), sedpocn(jpi,jpj), sedpoca(jpi,jpj),  &
-               fbod(jpi,jpj),    cmask(jpi,jpj)  ,                    &
-               Stat=sms_lobster_alloc)
-
-      IF(sms_lobster_alloc /= 0)THEN
-         CALL ctl_warn('sms_lobster_alloc : failed to allocate arrays.')
-      END IF
-
+      !
+      ALLOCATE( remdmp(jpk,jp_lobster),                                   &
+         &      neln(jpi,jpj),    xze(jpi,jpj),     xpar(jpi,jpj,jpk),    &
+         &      dminl(jpi,jpj),   dmin3(jpi,jpj,jpk),                     &
+         &      sedpocb(jpi,jpj), sedpocn(jpi,jpj), sedpoca(jpi,jpj),     &
+         &      fbod(jpi,jpj),    cmask(jpi,jpj)                    , STAT=sms_lobster_alloc )
+         !
+      IF( sms_lobster_alloc /= 0 )   CALL ctl_warn('sms_lobster_alloc : failed to allocate arrays')
+      !
    END FUNCTION sms_lobster_alloc
 
@@ -140,4 +132,3 @@
 
    !!======================================================================
-
 END MODULE sms_lobster
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2636)
@@ -10,11 +10,12 @@
    !!   'key_lobster'   :                                 LOBSTER bio-model
    !!----------------------------------------------------------------------
-   !! trc_nam_lobster      : LOBSTER model namelist read
-   !!----------------------------------------------------------------------
-   USE oce_trc         ! Ocean variables
-   USE par_trc         ! TOP parameters
-   USE trc             ! TOP variables
-   USE sms_lobster     ! sms trends
-   USE in_out_manager  ! I/O manager
+   !! trc_nam_lobster   : LOBSTER model namelist read
+   !!----------------------------------------------------------------------
+   USE oce_trc          ! Ocean variables
+   USE par_trc          ! TOP parameters
+   USE trc              ! TOP variables
+   USE sms_lobster      ! sms trends
+   USE in_out_manager   ! I/O manager
+   USE lib_mpp          ! MPP library
 
    IMPLICIT NONE
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2636)
@@ -21,4 +21,5 @@
    USE sms_lobster
    USE prtctl_trc      ! Print control for debbuging
+   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
@@ -69,6 +70,5 @@
 
       IF( (wrk_in_use(2, 1,2)) .OR. (wrk_in_use(3, 2,3)) )THEN
-         CALL ctl_stop('trc_opt : requested workspace arrays unavailable.')
-         RETURN
+         CALL ctl_stop('trc_opt : requested workspace arrays unavailable')   ;   RETURN
       END IF
 
@@ -138,7 +138,6 @@
       ENDIF
       !
-      IF( (wrk_not_released(2, 1,2)) .OR. (wrk_not_released(3, 2,3)) )THEN
-         CALL ctl_stop('trc_opt : failed to release workspace arrays.')
-      END IF
+      IF( wrk_not_released(2, 1,2)  .OR.  wrk_not_released(3, 2,3)  )   &
+          CALL ctl_stop('trc_opt : failed to release workspace arrays')
       !
    END SUBROUTINE trc_opt
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2636)
@@ -13,5 +13,5 @@
    !!   trcsms_lobster        :  Time loop of passive tracers sms
    !!----------------------------------------------------------------------
-   USE oce_trc         !
+   USE oce_trc          !
    USE trc
    USE trcbio
@@ -23,4 +23,5 @@
    USE trdmod_trc
    USE trdmld_trc
+   USE lib_mpp          ! MPP library
 
    IMPLICIT NONE
@@ -32,7 +33,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -53,8 +53,7 @@
       !! --------------------------------------------------------------------
 
-      IF(wrk_in_use(3,1))THEN
-         CALL ctl_stop('trc_sms_lobster : requested workspace array unavailable.')
-         RETURN
-      END IF
+      IF( wrk_in_use(3,1) ) THEN
+         CALL ctl_stop('trc_sms_lobster : requested workspace array unavailable')   ;   RETURN
+      ENDIF
 
       CALL trc_opt( kt )      ! optical model
@@ -72,8 +71,6 @@
       IF( lk_trdmld_trc )  CALL trd_mld_bio( kt )   ! trends: Mixed-layer
 
-      IF(wrk_not_released(3,1))THEN
-         CALL ctl_stop('trc_sms_lobster : failed to release workspace array.')
-      END IF
-
+      IF( wrk_not_released(3,1) )   CALL ctl_stop('trc_sms_lobster : failed to release workspace array.')
+      !
    END SUBROUTINE trc_sms_lobster
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2636)
@@ -10,5 +10,4 @@
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   trc_adv      : compute ocean tracer advection trend
@@ -27,5 +26,6 @@
    USE ldftra_oce      ! lateral diffusion coefficient on tracers
    USE in_out_manager  ! I/O manager
-   USE prtctl_trc          ! Print control
+   USE lib_mpp         ! MPP library
+   USE prtctl_trc      ! Print control
 
    IMPLICIT NONE
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2636)
@@ -3,5 +3,4 @@
    !!                       ***  MODULE  trcnxt  ***
    !! Ocean passive tracers:  time stepping on passives tracers
-   !!======================================================================
    !!======================================================================
    !! History :  7.0  !  1991-11  (G. Madec)  Original code
@@ -27,5 +26,4 @@
    !!   trc_nxt     : time stepping on passive tracers
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce_trc         ! ocean dynamics and tracers variables
    USE trc             ! ocean passive tracers variables
@@ -43,30 +41,27 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC trc_nxt          ! routine called by step.F90
-   PUBLIC trc_nxt_alloc    ! routine called by nemogcm.F90
+   PUBLIC   trc_nxt          ! routine called by step.F90
+   PUBLIC   trc_nxt_alloc    ! routine called by nemogcm.F90
 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::   r2dt
+
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
-   FUNCTION trc_nxt_alloc()
+   INTEGER FUNCTION trc_nxt_alloc()
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE trc_nxt_alloc  ***
       !!----------------------------------------------------------------------
-      INTEGER :: trc_nxt_alloc
+      USE lib_mpp, ONLY: ctl_warn
       !!----------------------------------------------------------------------
-
+      !
       ALLOCATE( r2dt(jpk), Stat=trc_nxt_alloc)
-
-      IF(trc_nxt_alloc /= 0)THEN
-         CALL ctl_warn('trc_nxt_alloc : failed to allocate array.')
-      ENDIF
-
+      !
+      IF( trc_nxt_alloc /= 0 )   CALL ctl_warn('trc_nxt_alloc : failed to allocate array')
+      !
    END FUNCTION trc_nxt_alloc
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2636)
@@ -16,16 +16,15 @@
    !!   trc_sbc      : update the tracer trend at ocean surface
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE oce_trc             ! ocean dynamics and active tracers variables
-   USE trc                 ! ocean  passive tracers variables
-   USE prtctl_trc          ! Print control for debbuging
+   USE oce_trc         ! ocean dynamics and active tracers variables
+   USE trc             ! ocean  passive tracers variables
+   USE prtctl_trc      ! Print control for debbuging
    USE trdmod_oce
    USE trdtra
+   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC trc_sbc              ! routine called by step.F90
+   PUBLIC   trc_sbc   ! routine called by step.F90
 
    !! * Substitutions
@@ -34,7 +33,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -62,8 +60,7 @@
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, zemps => wrk_2d_1
-      !! * Arguments
+      !
       INTEGER, INTENT( in ) ::   kt          ! ocean time-step index
-
-      !! * Local declarations
+      !
       INTEGER  ::   ji, jj, jn           ! dummy loop indices
       REAL(wp) ::   zsrau, zse3t   ! temporary scalars
@@ -73,6 +70,5 @@
 
       IF(wrk_in_use(2, 1))THEN
-         CALL ctl_stop('trc_sbc: requested workspace array unavailable.')
-         RETURN
+         CALL ctl_stop('trc_sbc: requested workspace array unavailable.')   ;   RETURN
       END IF
 
@@ -126,8 +122,6 @@
       ENDIF
 
-      IF(wrk_not_released(2, 1))THEN
-         CALL ctl_stop('trc_sbc: failed to release workspace array.')
-      END IF
-
+      IF( wrk_not_released(2, 1) )   CALL ctl_stop('trc_sbc: failed to release workspace array')
+      !
    END SUBROUTINE trc_sbc
 
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2636)
@@ -20,9 +20,10 @@
    USE trazdf_exp      ! vertical diffusion: explicit (tra_zdf_exp     routine)
    USE trazdf_imp      ! vertical diffusion: implicit (tra_zdf_imp     routine)
+   USE trdmod_oce
+   USE trdtra
    USE prtctl_trc      ! Print control
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE trdmod_oce
-   USE trdtra
+   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2636)
@@ -23,5 +23,5 @@
    USE zdfddm  , ONLY : avs  !: salinity vertical diffusivity coeff. at w-point
 # endif
-   USE trcnam_trp      ! passive tracers transport namelist variables
+   USE trcnam_trp        ! passive tracers transport namelist variables
    USE trdmod_trc_oce    ! definition of main arrays used for trends computations
    USE in_out_manager    ! I/O manager
@@ -30,4 +30,5 @@
    USE ioipsl            ! NetCDF library
    USE lbclnk            ! ocean lateral boundary conditions (or mpp link)
+   USE lib_mpp           ! MPP library
    USE trdmld_trc_rst    ! restart for diagnosing the ML trends
    USE prtctl            ! print control
@@ -47,5 +48,5 @@
    CHARACTER (LEN=40) ::  clhstnam                                ! name of the trends NetCDF file
    INTEGER ::   nmoymltrd
-   INTEGER ::   ndextrd1(jpi*jpj)
+   INTEGER, ALLOCATABLE, SAVE, DIMENSION(:) ::   ndextrd1
    INTEGER, DIMENSION(jptra) ::   nidtrd, nh_t
    INTEGER ::   ndimtrd1                        
@@ -87,10 +88,8 @@
                ztmltrdbio2(jpi,jpj,jpdiabio)     , &
 #endif
-               Stat=trd_mld_trc_alloc)
-
-      IF(trd_mld_trc_alloc/=0)THEN
-         CALL ctl_warn('trd_mld_trc_alloc : failed to allocate arrays.')
-      END IF
-
+         &     ndextrd1(jpi*jpj)                 ,  STAT=trd_mld_trc_alloc)
+         !
+      IF( lk_mpp                )   CALL mpp_sum ( trd_mld_trc_alloc )
+      IF( trd_mld_trc_alloc /=0 )   CALL ctl_warn('trd_mld_trc_alloc : failed to allocate arrays.')
    END FUNCTION trd_mld_trc_alloc
 
@@ -125,7 +124,6 @@
       !!----------------------------------------------------------------------
 
-      IF(wrk_in_use(2, 1))THEN
-         CALL ctl_stop('trd_mld_trc_zint : requested workspace array unavailable.')
-         RETURN
+      IF( wrk_in_use(2, 1) ) THEN
+         CALL ctl_stop('trd_mld_trc_zint : requested workspace array unavailable')   ;   RETURN
       END IF
 
@@ -213,10 +211,9 @@
       END SELECT
 
-      IF(wrk_not_released(2, 1))THEN
-         CALL ctl_stop('trd_mld_trc_zint : failed to release workspace array.')
-      END IF
-
+      IF( wrk_not_released(2, 1) )   CALL ctl_stop('trd_mld_trc_zint : failed to release workspace array.')
+      !
     END SUBROUTINE trd_mld_trc_zint
-    
+
+
     SUBROUTINE trd_mld_bio_zint( ptrc_trdmld, ktrd )
       !!----------------------------------------------------------------------
@@ -387,8 +384,8 @@
       !!       - See NEMO documentation (in preparation)
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, wrk_3d_1, wrk_3d_2, wrk_3d_3, wrk_3d_4, &
-                    wrk_3d_5, wrk_3d_6, wrk_3d_7, wrk_3d_8, &
-                    wrk_3d_9
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   wrk_3d_1, wrk_3d_2, wrk_3d_3, wrk_3d_4
+      USE wrk_nemo, ONLY:   wrk_3d_5, wrk_3d_6, wrk_3d_7, wrk_3d_8, wrk_3d_9
+      !
       INTEGER, INTENT( in ) ::   kt                               ! ocean time-step index
       INTEGER ::   ji, jj, jk, jl, ik, it, itmod, jn
@@ -414,8 +411,7 @@
       !!----------------------------------------------------------------------
 
-      IF(wrk_in_use(3, 1,2,3,4,5,6,7,8,9))THEN
-         CALL ctl_stop('trd_mld_trc : requested workspace arrays unavailable.')
-         RETURN
-      END IF
+      IF( wrk_in_use(3, 1,2,3,4,5,6,7,8,9) ) THEN
+         CALL ctl_stop('trd_mld_trc : requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
       ! Set-up pointers into sub-arrays of workspaces
       ztmltot   => wrk_3d_1(:,:,1:jptra)
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc_oce.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc_oce.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc_oce.F90	(revision 2636)
@@ -4,37 +4,32 @@
    !! Ocean trends :   set tracer and momentum trend variables
    !!======================================================================
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/TRD/trdmld_oce.F90,v 1.2 2005/03/27 18:35:23 opalod Exp $ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-#if defined key_top
+#if defined key_top   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
 
-   USE par_oce                        ! ocean parameters
-   USE par_trc                        ! passive tracers parameters
+   USE par_oce       ! ocean parameters
+   USE par_trc       ! passive tracers parameters
 
    IMPLICIT NONE
    PUBLIC
 
-   !!* Namelist namtoptrd:  diagnostics on passive tracers trends
-   INTEGER  ::    nn_trd_trc                 !: time step frequency dynamics and tracers trends
-   INTEGER  ::    nn_ctls_trc                !: control surface type for trends vertical integration
+   !                                         !!* Namelist namtoptrd:  diagnostics on passive tracers trends
+   INTEGER  ::    nn_trd_trc                  !: time step frequency dynamics and tracers trends
+   INTEGER  ::    nn_ctls_trc                 !: control surface type for trends vertical integration
    REAL(wp) ::    rn_ucf_trc                  !: unit conversion factor (for netCDF trends outputs)
-   LOGICAL  ::    ln_trdmld_trc_instant    !: flag to diagnose inst./mean ML trc trends
-   LOGICAL  ::    ln_trdmld_trc_restart    !: flag to restart mixed-layer trc diagnostics
-   CHARACTER(len=50) ::  cn_trdrst_trc_in  !: suffix of pass. tracer restart name (input)
-   CHARACTER(len=50) ::  cn_trdrst_trc_out !: suffix of pass. tracer restart name (output)
+   LOGICAL  ::    ln_trdmld_trc_instant       !: flag to diagnose inst./mean ML trc trends
+   LOGICAL  ::    ln_trdmld_trc_restart       !: flag to restart mixed-layer trc diagnostics
+   CHARACTER(len=50) ::  cn_trdrst_trc_in     !: suffix of pass. tracer restart name (input)
+   CHARACTER(len=50) ::  cn_trdrst_trc_out    !: suffix of pass. tracer restart name (output)
    LOGICAL, DIMENSION (jptra) ::   ln_trdtrc  !: large trends diagnostic to write or not (namelist)
 
 # if defined key_trdtrc && defined key_iomput
    LOGICAL, PARAMETER ::   lk_trdtrc = .TRUE. 
-#else
+# else
    LOGICAL, PARAMETER ::   lk_trdtrc = .FALSE.   !: ML trend flag
-#endif
+# endif
 
-#if defined key_trdmld_trc
+# if defined key_trdmld_trc   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_trdmld_trc'                     mixed layer trends diagnostics
@@ -108,9 +103,9 @@
       tmltrdm_trc                                !: total cumulative trends over the analysis window
 
-#else
+# else
    LOGICAL, PARAMETER ::   lk_trdmld_trc = .FALSE.   !: ML trend flag
-#endif
+# endif
 
-#if defined key_lobster
+# if defined key_lobster
    CHARACTER(LEN=80) :: clname_bio, ctrd_bio(jpdiabio,2)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  &
@@ -121,23 +116,17 @@
       tmltrd_csum_ub_bio                         !: before (prev. analysis period) cumulated sum over the
                                                  !: upper triangle
-#endif
-
-#else
+# endif
    !!----------------------------------------------------------------------
-   !!  Empty module :                                     No passive tracer
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/TRD/trdmld_oce.F90,v 1.2 2005/03/27 18:35:23 opalod Exp $ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-#endif
-
-#if defined key_top
 CONTAINS
 
-   FUNCTION trd_mod_trc_oce_alloc()
+   INTEGER FUNCTION trd_mod_trc_oce_alloc()
       !!----------------------------------------------------------------------
       !!         *** ROUTINE trd_mod_trc_oce_alloc ***
       !!----------------------------------------------------------------------
-      USE in_out_manager, ONLY: ctl_warn
-      !
-      INTEGER :: trd_mod_trc_oce_alloc
-      ! Locals
+      USE lib_mpp, ONLY: ctl_warn
       INTEGER :: ierr(2)
       !!----------------------------------------------------------------------
@@ -145,5 +134,5 @@
       ierr(:) = 0
 
-#if defined key_trdmld_trc
+# if defined key_trdmld_trc
       ALLOCATE(nmld_trc(jpi,jpj),          nbol_trc(jpi,jpj),           &
                wkx_trc(jpi,jpj,jpk),       rmld_trc(jpi,jpj),           &
@@ -166,6 +155,6 @@
                tmltrdm_trc(jpi,jpj,jptra),                   &
                Stat=ierr(1))
-#endif
-#if defined key_lobster
+# endif
+# if defined key_lobster
       ALLOCATE(tmltrd_bio(jpi,jpj,jpdiabio),         &
                tmltrd_sum_bio(jpi,jpj,jpdiabio),     &
@@ -173,20 +162,22 @@
                tmltrd_csum_ub_bio(jpi,jpj,jpdiabio), &
                Stat=ierr(2))
-#endif
+# endif
 
       trd_mod_trc_oce_alloc = MAXVAL(ierr)
 
-      IF(trd_mod_trc_oce_alloc /= 0)THEN
-         CALL ctl_warn('trd_mod_trc_oce_alloc : failed to allocate arrays.')
-      END IF
+      IF( trd_mod_trc_oce_alloc /= 0 )   CALL ctl_warn('trd_mod_trc_oce_alloc : failed to allocate arrays')
 
-#if defined key_trdmld_trc
-      ! Initialise what used to be a parameter - max level for mixed-layer 
-      ! trends diag.
-      jpktrd_trc = jpk
+# if defined key_trdmld_trc
+      jpktrd_trc = jpk      ! Initialise what used to be a parameter - max level for mixed-layer trends diag.
+# endif
+      !
+   END FUNCTION trd_mod_trc_oce_alloc
+
+#else
+   !!----------------------------------------------------------------------
+   !!  Empty module :                                     No passive tracer
+   !!----------------------------------------------------------------------
 #endif
 
-   END FUNCTION trd_mod_trc_oce_alloc
-#endif
-
+   !!======================================================================
 END MODULE trdmod_trc_oce
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2636)
@@ -78,8 +78,7 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,  :) ::   trc2d    !:  additional 2d outputs  
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:,:) ::   trc3d    !:  additional 3d outputs  
-   
 # endif
 
-#if defined key_diabio || defined key_trdmld_trc
+# if defined key_diabio || defined key_trdmld_trc
    !                                                              !!*  namtop_XXX namelist *
    INTEGER , PUBLIC                               ::   nn_writebio   !: time step frequency for biological outputs 
@@ -87,5 +86,5 @@
    CHARACTER(len=20), PUBLIC, DIMENSION(jpdiabio) ::   ctrbiu      !: biological trends unit   
    CHARACTER(len=80), PUBLIC, DIMENSION(jpdiabio) ::   ctrbil      !: biological trends long name
-#endif
+# endif
 # if defined key_diabio
    !! Biological trends
@@ -101,27 +100,18 @@
 # endif
 
-#else
-   !!----------------------------------------------------------------------
-   !!  Empty module :                                     No passive tracer
-   !!----------------------------------------------------------------------
-#endif
-
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!======================================================================
-#if defined key_top
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   FUNCTION trc_alloc()
+   INTEGER FUNCTION trc_alloc()
       !!-------------------------------------------------------------------
       !!                    *** ROUTINE trc_alloc ***
       !!-------------------------------------------------------------------
-      USE in_out_manager, ONLY: ctl_warn
+      USE lib_mpp, ONLY: ctl_warn
+      !!-------------------------------------------------------------------
       !
-      INTEGER :: trc_alloc
-      !!-------------------------------------------------------------------
-
       ALLOCATE(cvol(jpi,jpj,jpk),                                  &
                trn(jpi,jpj,jpk,jptra),                             &
@@ -132,16 +122,20 @@
 # if defined key_diatrc && ! defined key_iomput
                trc2d(jpi,jpj,jpdia2d), trc3d(jpi,jpj,jpk,jpdia3d), &
-#endif
+# endif
 # if defined key_diabio
                trbio(jpi,jpj,jpk,jpdiabio),                        &
-#endif
-               Stat=trc_alloc)
+# endif
+               STAT=trc_alloc)
 
-      IF(trc_alloc /= 0)THEN
-         CALL ctl_warn('trc_alloc: failed to allocate arrays.')
-      END IF
-
+      IF( trc_alloc /= 0 )   CALL ctl_warn('trc_alloc: failed to allocate arrays')
+      !
    END FUNCTION trc_alloc
+   
+#else
+   !!----------------------------------------------------------------------
+   !!  Empty module :                                     No passive tracer
+   !!----------------------------------------------------------------------
 #endif
 
+   !!======================================================================
 END MODULE trc
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2635)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2636)
@@ -27,4 +27,5 @@
    USE trcnam_my_trc     ! MY_TRC SMS namelist
    USE in_out_manager    ! I/O manager
+   USE lib_mpp           ! MPP library
    USE trdmod_trc_oce
 
